#include "pacula.h"

Cell::Cell()
{
}


Cell::Cell(	bool up,
			bool down,
			bool left,
			bool right,
			bool power) :
powerPellet(power),
pellet(true)
{
	bounds[0] = up;
	bounds[1] = down;
	bounds[2] = left;
	bounds[3] = right;
}


Cell::Cell(	short	bounds,
			bool	power) :
powerPellet(power),
pellet(true)
{
	this->bounds[0] = ((bounds & 1) != 0);
	this->bounds[1] = ((bounds & 2) != 0);
	this->bounds[2] = ((bounds & 4) != 0);
	this->bounds[3] = ((bounds & 8) != 0);
}


bool Cell::canMoveUp()
{
	return bounds[0];
}


bool Cell::canMoveDown()
{
	return bounds[1];
}


bool Cell::canMoveLeft()
{
	return bounds[2];
}


bool Cell::canMoveRight()
{
	return bounds[3];
}


bool Cell::hasPellet()
{
	return pellet;
}


bool Cell::hasPowerPellet()
{
	return pellet && powerPellet;
}


void Cell::eatPellet()
{
	pellet = false;
}

void Cell::draw(BITMAP*	bitmap,
				Point*	offset,
				Point*	cell,
				int		cellWidth,
				int		wallWidth,
				int		colour)
{
	Point pos(offset->x + cell->x * (cellWidth + wallWidth), offset->y + cell->y * (cellWidth + wallWidth));
	
	if (canMoveUp() && (!canMoveDown()) && (!canMoveLeft()) && (!canMoveRight()))
	{
		for (int i=0; i < cellWidth+2*wallWidth-1; ++i)
		{
			vline(bitmap, pos.x + i, pos.y, pos.y + wallWidth - 1, (i%6)>2 ? colour : 0);
		}
	}
	else if (!canMoveUp())
	{
		rectfill(bitmap,
				 pos.x,
				 pos.y,
				 pos.x + cellWidth + 2 * wallWidth - 1,
				 pos.y + wallWidth - 1,
				 colour);
	}
	
	if (!canMoveDown())
	{
		rectfill(bitmap,
				 pos.x,
				 pos.y + cellWidth + wallWidth,
				 pos.x + cellWidth + 2 * wallWidth - 1,
				 pos.y + cellWidth + 2 * wallWidth - 1,
				 colour);
	}
	
	if (!canMoveLeft())
	{
		rectfill(bitmap,
				 pos.x,
				 pos.y,
				 pos.x + wallWidth - 1,
				 pos.y + cellWidth + 2 * wallWidth - 1,
				 colour);
	}
	
	if (!canMoveRight())
	{
		rectfill(bitmap,
				 pos.x + cellWidth + wallWidth,
				 pos.y,
				 pos.x + cellWidth + 2 * wallWidth - 1,
				 pos.y + cellWidth + 2 * wallWidth - 1,
				 colour);
	}
}
